$	set noon
$	set nover
$ !
$ !	Command file to compile and install Kermit on a VAX/VMS system.
$ !	Note:  Please examine comments marked by *****, they will describe
$ !	modifications necessary to install kermit for your system.  After
$ !	running install, be sure to modify systartup.com, and sylogin.com.
$ !
$ !	Author: Bruce W. Pinn
$ !	Site:   University of Toronto Computing Services
$ !	Date:   May 31, 1983
$ !
$ !	Modified: Philip Murton 
$ !	Date:   Sept. 18, 1984
$ !
$ !	Added 'hex' file.	
$ !
$	on control_y then goto fini
$	sysdisk := f$logical("SYS$DISK")
$	kermitdirect := 'f$directory()
$	defuic := 'f$user()
$	write sys$output " "
$	write sys$output "		Kermit-VMS Install Procedure"
$	write sys$output " "
$	inquire answer " Rebuild from sources? (YES or no)"
$	if answer .eqs. "" then goto Build_Source
$	if answer then goto Build_Source
$	inquire answer " Build from HEX file? (YES or no)"
$	if answer .eqs. "" then goto HEX_file
$	if answer then goto HEX_file
$	goto Install
$ Build_Source:
$	inquire answer " Do you have a PASCAL Compiler? (YES or no)"
$	if answer .eqs. "" then goto Create_Kermit
$	if answer then goto Create_Kermit
$ HEX_file:
$	write sys$output " "
$	write sys$output " Creating Kermit.exe from Kermit.hex"
$	write sys$output " 	(Fortran used for this)"
$	write sys$output " "
$	@hex
$	goto Install
$ Create_Kermit:
$	set prot=(s:rwed,g:rwed,o:rwed,w:re)/default
$	@pas
$	@fort
$	@link
$ Finished_Comp:
$	inquire answer " Install Kermit-VMS on the system? (YES or no)"
$	if answer .eqs. "" then goto install
$	if answer then goto install
$	goto Fini
$ Install:
$	set proc/priviledge=(cmk,sysprv,sysnam,log_io)
$	set uic [1,4]
$	write sys$output " Installing image, and defining system logical names."
$	copy kermit.exe sys$system:kermit.exe
$ !******
$ !	Modify terminal list for your site. (ie. replace terminal list with a
$ !	list of terminals that you will be using for out-dialing from your
$ !	VAX).  List should appear as follows:
$ !		assign/system "_TTA1: _TTA2: _TTA3:" kermit$rem0
$ !******
$	assign/system {terminal list} kermit$rem0
$ !******
$ !	Replicate the following line once for each terminal in your terminal
$ !	list.  Replace {AAAAA} with one terminal in list.  (ie. for above
$ !	example :
$ !	set terminal _TTA1:/PERM/NOMODEM/NOEIGHT/NOAUTOBAUD/ALTYPEAHD
$ !	set terminal _TTA2:/PERM/NOMODEM/NOEIGHT/NOAUTOBAUD/ALTYPEAHD
$ !	set terminal _TTA3:/PERM/NOMODEM/NOEIGHT/NOAUTOBAUD/ALTYPEAHD
$ !******
$	set terminal {AAAAAA} /PERM/NOMODEM/NOEIGHT/NOAUTOBAUD/HOST/TTSYNC -
				/ALTYPEAHD
$ !******
$ !	Modify kermit directory to reflect the locations where kermit source
$ !	is held.  For example :
$ !	assign/system DRA0:[KERMIT] kermdir:
$ !******
$	assign/system {kermit directory} kermdir:
$	assign/system kermdir:kermit.txt kermithlp:
$	mcr install
SYS$SYSTEM:KERMIT.EXE/PRIV=(SYSPRV,ALTPRI,PSWAPM)
$	write sys$output " Please insert the following lines into your system"
$	write sys$output " startup file (ie. SYSTARTUP.COM) :"
$	write sys$output "	$ assign/system ""{terminal list}"" kermit$rem0
$	write sys$output "	$ assign/system sys$help:kermit.hlp kermithlp:"
$	write sys$output "	$ mcr install
$	write sys$output "	SYS$SYSTEM:KERMIT.EXE/PRIV=(SYSPRIV,ALTPRI,PSAWPM)
$	write sys$output " "
$	write sys$output " Also insert the following lines in your system wide"
$	write sys$output " login file :"
$	write sys$output "	$ assign 'f$logical("SYS$OUTPUT")' kermit$local
$	write sys$output "	$ kermit := $sys$system:kermit.exe"
$ Fini:
$	if "''defuic'" .nes. "" then set uic 'defuic
$	set process/priv=(nocmk,nosysprv,nolog_io,nosysnam)
$	set on
$	exit
